All Classes Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
QoreFloatNode Class Reference

Qore's floating-point value type, dynamically-allocated only, reference counted. More...

`#include <QoreFloatNode.h>`

Inheritance diagram for QoreFloatNode:
[legend]
Collaboration diagram for QoreFloatNode:
[legend]

## Public Member Functions

DLLEXPORT | QoreFloatNode (double n_f)
| creates a new floating-point value and assigns the initial value to it
DLLEXPORT | QoreFloatNode ()
| creates a new floating-point value and assigns 0.0 to it
virtual DLLEXPORT QoreString * | getStringRepresentation (bool &del) const
| returns the floating-point value converted to a string and sets del to true
virtual DLLEXPORT void | getStringRepresentation (QoreString &str) const
| concatentates the floating-point value to an existing QoreString reference, default implementation does nothing
virtual DLLEXPORT class DateTime * | getDateTimeRepresentation (bool &del) const
| returns the DateTime representation of this value and sets del to true
virtual DLLEXPORT void | getDateTimeRepresentation (DateTime &dt) const
| assigns the date representation of the value to the DateTime reference passed
virtual DLLEXPORT int | getAsString (QoreString &str, int foff, class ExceptionSink *xsink) const
| concatenate the string representation of the floating-point value to an existing QoreString
virtual DLLEXPORT QoreString * | getAsString (bool &del, int foff, class ExceptionSink *xsink) const
| returns a QoreString giving the string representation of the floating-point value, sets del to true
virtual DLLEXPORT class AbstractQoreNode * | realCopy () const
| returns a copy of the object; the caller owns the reference count
virtual DLLEXPORT bool | is_equal_soft (const AbstractQoreNode *v, ExceptionSink *xsink) const
| tests for equality with possible type conversion (soft compare)
virtual DLLEXPORT bool | is_equal_hard (const AbstractQoreNode *v, ExceptionSink *xsink) const
| tests for equality without type conversions (hard compare)
virtual DLLEXPORT const char * | getTypeName () const
| returns the type name as a c string
virtual DLLLOCAL AbstractQoreNode * | parseInit (LocalVar *oflag, int pflag, int &lvids, const QoreTypeInfo *&typeInfo)
| returns the type information
Public Member Functions inherited from SimpleValueQoreNode
DLLLOCAL | SimpleValueQoreNode (qore_type_t t, bool n_there_can_be_only_one=false)
| creates the object by assigning the type code and setting the "value" flag, unsetting the "needs_eval" flag, and setting "there_can_be_only_one"
Public Member Functions inherited from SimpleQoreNode
DLLLOCAL | SimpleQoreNode (qore_type_t t, bool n_value, bool n_needs_eval, bool n_there_can_be_only_one=false)
| constructor takes the type and value arguments
DLLLOCAL | SimpleQoreNode (const SimpleQoreNode &v)
| copy constructor
Public Member Functions inherited from AbstractQoreNode
DLLEXPORT | AbstractQoreNode (qore_type_t t, bool n_value, bool n_needs_eval, bool n_there_can_be_only_one=false, bool n_custom_reference_handlers=false)
| constructor takes the type
DLLEXPORT | AbstractQoreNode (const AbstractQoreNode &v)
| copy constructor
DLLEXPORT bool | getAsBool () const
| returns the boolean value of the object
DLLEXPORT int | getAsInt () const
| returns the integer value of the object
DLLEXPORT int64 | getAsBigInt () const
| returns the 64-bit integer value of the object
DLLEXPORT double | getAsFloat () const
| returns the float value of the object
DLLLOCAL bool | needs_eval () const
| returns true if the object needs evaluation to return a value, false if not
DLLLOCAL qore_type_t | getType () const
| returns the data type
DLLEXPORT AbstractQoreNode * | eval (ExceptionSink *xsink) const
| evaluates the object and returns a value (or 0)
DLLEXPORT AbstractQoreNode * | eval (bool &needs_deref, ExceptionSink *xsink) const
| optionally evaluates the argument
DLLEXPORT int64 | bigIntEval (ExceptionSink *xsink) const
| evaluates the object and returns a 64-bit integer value
DLLEXPORT int | integerEval (ExceptionSink *xsink) const
| evaluates the object and returns an integer value
DLLEXPORT bool | boolEval (ExceptionSink *xsink) const
| evaluates the object and returns a boolean value
DLLEXPORT double | floatEval (ExceptionSink *xsink) const
| evaluates the object and returns a floating-point value
DLLLOCAL bool | is_value () const
| returns true if the node represents a value
DLLEXPORT void | deref (ExceptionSink *xsink)
| decrements the reference count and calls derefImpl() if there_can_be_only_one is false, otherwise does nothing
DLLEXPORT AbstractQoreNode * | refSelf () const
| returns "this" with an incremented reference count
DLLEXPORT void | ref () const
| increments the reference count
DLLLOCAL bool | isReferenceCounted () const
| returns true if the object is reference-counted
Public Member Functions inherited from QoreReferenceCounter
DLLEXPORT | QoreReferenceCounter ()
| creates the reference counter object
DLLEXPORT | ~QoreReferenceCounter ()
| destroys the reference counter object
DLLLOCAL int | reference_count () const
| gets the reference count
DLLLOCAL bool | is_unique () const
| returns true if the reference count is 1
DLLEXPORT void | ROreference () const
| atomically increments the reference count
DLLEXPORT bool | ROdereference () const
| atomically decrements the reference count

## Static Public Member Functions

static DLLLOCAL const char * | getStaticTypeName ()
| returns the type name (useful in templates)
static DLLLOCAL qore_type_t | getStaticTypeCode ()
| returns the type code (useful in templates)
static DLLLOCAL double | getValue (AbstractQoreNode *v)
| returns the value of the argument (useful in templates)

## Public Attributes

double | f
| the value of the type

## Protected Member Functions

virtual DLLEXPORT | ~QoreFloatNode ()
| the destructor is protected because it should not be called directly
Protected Member Functions inherited from SimpleValueQoreNode
virtual DLLEXPORT AbstractQoreNode * | evalImpl (ExceptionSink *xsink) const
| should never be called for value types
virtual DLLEXPORT AbstractQoreNode * | evalImpl (bool &needs_deref, ExceptionSink *xsink) const
| should never be called for value types
virtual DLLEXPORT int64 | bigIntEvalImpl (ExceptionSink *xsink) const
| should never be called for value types
virtual DLLEXPORT int | integerEvalImpl (ExceptionSink *xsink) const
| should never be called for value types
virtual DLLEXPORT bool | boolEvalImpl (ExceptionSink *xsink) const
| should never be called for value types
virtual DLLEXPORT double | floatEvalImpl (ExceptionSink *xsink) const
| should never be called for value types

## Additional Inherited Members

Protected Attributes inherited from AbstractQoreNode
qore_type_t | type: 11
| the type of the object
bool | value: 1
| this is true for values, if false then either the type needs evaluation to produce a value or is a parse expression
bool | needs_eval_flag: 1
| if this is true then the type can be evaluated
bool | there_can_be_only_one: 1
| if this is set to true, then reference counting is turned off for objects of this class
bool | custom_reference_handlers: 1
| set to one for objects that need custom reference handlers

## Detailed Description

Qore's floating-point value type, dynamically-allocated only, reference counted.

## Constructor & Destructor Documentation

virtual DLLEXPORT QoreFloatNode::~QoreFloatNode | ( |  | ) |

protectedvirtual

the destructor is protected because it should not be called directly

See Also
  SimpleValueQoreNode::deref()

DLLEXPORT QoreFloatNode::QoreFloatNode | ( | double | n_f | ) |

creates a new floating-point value and assigns the initial value to it

Parameters

  n_f | the value for the object

## Member Function Documentation

virtual DLLEXPORT int QoreFloatNode::getAsString | ( | QoreString & | str,
|  | int | foff,
|  | class ExceptionSink * | xsink
| ) |  | const

virtual

concatenate the string representation of the floating-point value to an existing QoreString

used for n and N printf formatting

Parameters

  str | the string representation of the type will be concatenated to this QoreString reference
  foff | for multi-line formatting offset, ignored by this implementation of the function
  xsink | ignored by this implementation of the function

Returns
  -1 for exception raised, 0 = OK

Implements AbstractQoreNode.

virtual DLLEXPORT QoreString* QoreFloatNode::getAsString | ( | bool & | del,
|  | int | foff,
|  | class ExceptionSink * | xsink
| ) |  | const

virtual

returns a QoreString giving the string representation of the floating-point value, sets del to true

Used for n and N printf formatting. Do not call this function directly; use the QoreNodeAsStringHelper class (defined in QoreStringNode.h) instead

Parameters

  del | if this is true when the function returns, then the returned QoreString pointer should be deleted, if false, then it must not be
  foff | for multi-line formatting offset, ignored by this implementation of the function
  xsink | ignored by this implementation of the function

See Also
  QoreNodeAsStringHelper

Implements AbstractQoreNode.

virtual DLLEXPORT class DateTime* QoreFloatNode::getDateTimeRepresentation | ( | bool & | del | ) | const

virtual

returns the DateTime representation of this value and sets del to true

The DateTime representation is calculated by converting the floating-point value to an integer interpreted as the number of seconds offset from January 1, 1970.

Note
  Use the DateTimeValueHelper class instead of using this function directly

Parameters

  del | output parameter: if del is true, then the returned DateTime pointer belongs to the caller (and must be deleted manually), if false, then it must not be

See Also
  DateTimeValueHelper

Reimplemented from AbstractQoreNode.

virtual DLLEXPORT void QoreFloatNode::getDateTimeRepresentation | ( | DateTime & | dt | ) | const

virtual

assigns the date representation of the value to the DateTime reference passed

The DateTime representation is calculated by converting the floating-point value to an integer interpreted as the number of seconds offset from January 1, 1970.

Parameters

  dt | the DateTime reference to be assigned

Reimplemented from AbstractQoreNode.

static DLLLOCAL const char* QoreFloatNode::getStaticTypeName | ( |  | ) |

inlinestatic

returns the type name (useful in templates)

Returns
  the type name as a c string

virtual DLLEXPORT QoreString* QoreFloatNode::getStringRepresentation | ( | bool & | del | ) | const

virtual

returns the floating-point value converted to a string and sets del to true

NOTE: do not use this function directly, use QoreStringValueHelper instead

Parameters

  del | output parameter: del is set to true, meaning that the resulting QoreString pointer belongs to the caller (and must be deleted manually)

Returns
  a QoreString pointer, use the del output parameter to determine ownership of the pointer

See Also
  QoreStringValueHelper

Reimplemented from AbstractQoreNode.

virtual DLLEXPORT void QoreFloatNode::getStringRepresentation | ( | QoreString & | str | ) | const

virtual

concatentates the floating-point value to an existing QoreString reference, default implementation does nothing

Parameters

  str | a reference to a QoreString where the value of the type will be concatenated

Reimplemented from AbstractQoreNode.

virtual DLLEXPORT const char* QoreFloatNode::getTypeName | ( |  | ) | const

virtual

returns the type name as a c string

Returns
  the type name as a c string

Implements AbstractQoreNode.

virtual DLLEXPORT bool QoreFloatNode::is_equal_hard | ( | const AbstractQoreNode * | v,
|  | ExceptionSink * | xsink
| ) |  | const

virtual

tests for equality without type conversions (hard compare)

Parameters

  v | the value to compare
  xsink | ignored by this implementation of the function

Returns
  true if the objects are equal, false if not

Implements AbstractQoreNode.

virtual DLLEXPORT bool QoreFloatNode::is_equal_soft | ( | const AbstractQoreNode * | v,
|  | ExceptionSink * | xsink
| ) |  | const

virtual

tests for equality with possible type conversion (soft compare)

Parameters

  v | the value to compare
  xsink | ignored by this implementation of the function

Returns
  true if the objects are equal, false if not

Implements AbstractQoreNode.

virtual DLLEXPORT class AbstractQoreNode* QoreFloatNode::realCopy | ( |  | ) | const

virtual

returns a copy of the object; the caller owns the reference count

Returns
  a copy of the object; the caller owns the reference count

Implements AbstractQoreNode.

The documentation for this class was generated from the following file:

- include/qore/QoreFloatNode.h (5431)